<template>
    <div>
        <crumbs title="license维护" style="min-width: 980px">
            <el-form :inline="true" class="demo-form-inline">
                <!-- <el-form-item label="标签类型：">
                    <el-select size="mini" v-model="filter.tagType[0]" placeholder="标签类型" clearable>
                        <el-option v-for="item in tagTypes" :label="item.name" :value="item.val" :key="item.id"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="标签归属：">
                    <el-select size="mini" v-model="filter.tagAdscription" @change="getValue"  placeholder="标签归属" clearable>
                        <el-option v-for="item in Adscriptions" :label="item.name" :value="item.val" :key="item.id" ></el-option>
                    </el-select>
                </el-form-item> -->
                <el-form-item label="服务商：">
                    <el-input size="mini" v-model.trim="filter.server" placeholder="标签系统名称"  maxlength="255" clearable></el-input>
                </el-form-item>
                <el-form-item label="医院：">
                    <el-input size="mini" v-model.trim="filter.hospital" placeholder="标签系统名称" maxlength="255" clearable></el-input>
                </el-form-item>
                <el-form-item>
                    <el-button size="mini" @click="filterDatas">确认</el-button>
                    <el-button size="mini" type="warning" @click="addToken">新增license</el-button>
                </el-form-item>
            </el-form>
        </crumbs>
        <div class="contents">
            <el-table
                :data="list"
                border
                style="width: 100%">
                <el-table-column
                    :resizable = "false"
                    type="index"
                    :index = 'indexMethod'
                    label="编号"
                    width="60">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="gmtModified"
                    label="操作时间"
                    width="180">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="server"
                    label="服务商">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="hospital"
                    label="医院">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="remainDay"
                    label="license有效天数">
                </el-table-column>
                 <el-table-column
                    :resizable = "false"
                    prop="validTime"
                    label="token有效时间（分钟）">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="loginKey"
                    label="loginKey">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="modifier"
                    label="操作人">
                </el-table-column>
                <el-table-column
                    :resizable = "false"
                    prop="operate"
                    label="操作">
                    <template slot-scope="scope">
                        <el-button  @click="modifyTagGroup(scope.row, 'modify')" type="text" size="small">修改</el-button>
                        <span style="margin:0 3px;">|</span>
                        <el-button @click="downLoadFile(scope.row)" type="text" size="small">下载</el-button>
                        <span style="margin:0 3px;">|</span>
                        <el-button @click="showDelDialog(scope.row.id)" class="delete" type="text" size="small">删除</el-button>
                        
                    </template>
                </el-table-column>
            </el-table>
        <div class="pagination">
            <el-pagination :current-page.sync="currentPage"
                       @current-change="currentChange"
                       background
                       :page-size="pageSize"
                        :page-sizes="pageSizeArr"
                        @size-change="handleSizeChange"
                        :layout="pageLayout"
                       :total="total">
            </el-pagination>
        </div>
        </div>
        
    </div>
</template>

<script>
import api from '@api/safeControl.js';
import config from '@api/config.js';
import $ from 'jquery';

export default {
    name: 'TokenControl',
    data: function() {
        return {
            list: [],
            filter: {
              hospital:'', 
              server:''
            },
            currentPage: 1,
            modifier: '',
            pageSize: config.pageSize,
            pageSizeArr:config.pageSizeArr,
            pageLayout:config.pageLayout,
            total: 0,
        }
    },
    created() {
        const userLoginDTO = JSON.parse(localStorage.getItem('userLoginDTO'))
        this.modifier = userLoginDTO && userLoginDTO.linkman
        this.getDataList()
        
    },
    watch: {
        'filter': {
            handler: function () {
            this.searched = false;
            },
            deep: true
        }
    },
    beforeRouteEnter(to, from, next) {
        next(vm => {
        //const pm = to.param;
        Object.assign(vm, to.params);
        vm.inCurrentPage=to.params.currentPage;
        })
    },
    methods: {
        handleSizeChange(val){
            this.pageSize = val;
            this.currentPage = utils.getCurrentPage(this.currentPage, this.total, this.pageSize);
            this.getDataList();
        },
        getDataList(isTurnPage) {
            const param = this.getFilterItems(isTurnPage);
            this.searched = true;
            const loading = this.$loading({
                lock: true,
                text: 'Loading',
                spinner: 'el-icon-loading',
                background: 'rgba(0, 0, 0, 0.7)'
            });
            api.tokenList(param).then((res) => { 
                    loading.close()
                const list = res.data.data.records
                
                this.list = list;
                this.total = res.data.data.total;
                if(this.inCurrentPage!==undefined){
                    this.currentPage=this.inCurrentPage;
                    this.inCurrentPage = undefined;
                }
            })
        },
        filterDatas() {
            this.currentPage = 1;
            this.getDataList();
        },
        addToken() {
            const pam = this.searched ? {
            currentPage: this.currentPage,
            pageSize:this.pageSize,
            filter: this.filter
            } : {currentPage: this.currentPage,
            pageSize:this.pageSize};
            this.$router.push({name: 'AddToken', params: pam});
        },
        modifyTagGroup(row, type) {
            api.tokenDetails({id:row.id}).then((res)=>{
                const {code,data,msg} = res.data;
                if(code=='0'){
                    const item = Object.assign({},row,data);
                    const pam = this.searched ? {
                    currentPage: this.currentPage,
                    filter: this.filter
                    } : {currentPage: this.currentPage};
                    // console.log('item', item)
                    if(type == 'modify') {
                        this.$router.push({
                        name: 'AddToken',
                        params: Object.assign(pam, {isEdit: true, data: item})
                        });
                    } else {
                        return
                    }
                }else{
                    this.$message({
                    message: msg,
                    type: 'warning'
                    });
                }
            });
        },
        downLoadFile(row) {
            const url = row.url.replace(/{imageUrlPrefix}/g,config.imgHost) + '?download=1'
            // var $form = $('<form method="GET"></form>');
            // $form.attr('action', url);
            // $form.appendTo($('body'));
            // $form.submit();
            this.download(url, 'license.properties')
        //     const ele = document.createElement('a');
        //     ele.setAttribute('download' , 'download');//用于设置下载文件的文件名

        //     ele.setAttribute('href',url); //设置下载文件的url地址


        //     ele.click();


        },
        getBlob(url,cb) {
            var xhr = new XMLHttpRequest();
            xhr.open('GET', url, true);
            xhr.responseType = 'blob';
            xhr.onload = function() {
                    if (xhr.status === 200) {
                        cb(xhr.response);
                    }
            };
            xhr.send();
        },
        saveAs(blob, filename) {
            if (window.navigator.msSaveOrOpenBlob) {
                navigator.msSaveBlob(blob, filename);
            } else {
                var link = document.createElement('a');
                var body = document.querySelector('body');

                link.href = window.URL.createObjectURL(blob);
                link.download = filename;

                // fix Firefox
                link.style.display = 'none';
                body.appendChild(link);
                
                link.click();
                body.removeChild(link);

                window.URL.revokeObjectURL(link.href);
            };
        },
        download(url, filename){
            const that = this
            that.getBlob(url, function(blob) {
                that.saveAs(blob, filename);
            });
        },
        currentChange(next) {
            this.currentPage = next;
            this.getDataList(true);
        },
        getFilterItems(isTurnPage) {
            //翻页时筛选条件没点确定则清空
            if(isTurnPage&&!this.searched){
            this.clearFilter();
            };
            const param = {
                current: this.inCurrentPage||this.currentPage,
                size: this.pageSize,
                hospital: this.filter.hospital,
                server: this.filter.server
            };
            return param;
        },
        indexMethod(index) {
            return ((this.currentPage - 1) * this.pageSize) + index + 1;
        },
        warning(msg,type){
            this.$message({
            showClose: true,
            dangerouslyUseHTMLString: true,
            message:'<p>'+msg+'</p>',
            type:type||'warning'
            })
        },
        showConfirmDialog(msg,resolve){
            this.$alert(msg, '提示', {
            confirmButtonText: '确定',
            type: 'warning'
            }).then(() => {
            resolve();
            }).catch(() => {});
        },
        clearFilter(){
        
        },
        showDelDialog(id){
            this.showConfirmDialog('是否删除该令牌？',()=>{
            const param = {id:id,creator:this.modifier}
            api.tokenDelete(param).then((res)=>{
                if(res.data.code=='0'){
                if(!this.searched){
                    //未点确认时清空搜索条件
                    this.clearFilter();
                }
                if(this.list.length==1){
                    //当前在最后一页且只有一条数据时，删除后跳到前一页
                    this.currentPage = this.currentPage===1?1:this.currentPage-1;
                }
                this.getDataList();
                this.warning(res.data.msg || '操作成功','success');
                }else{
                this.warning(res.data.msg);
                }
            }).catch((error)=>{
                this.warning(error);
            })
            });
        }
    }
}
</script>


<style lang="less">
    @import "../../less/admin.less";
    .delete{
       color: red;
    }
    .delete:hover {
        color: red;
    } 
    .pagination {
        min-width: 1010px;
    }
</style>